/* strategy.h
 *
 
 */
#ifndef STRATEGY_H
#define STRATEGY_H

#include "data.h"
#include "util.h"

class Strategy {
  public:
    Strategy( int dx, int dy );
    int doMove();

    void setData( Data * data ) { this->data = data; }
    void setUtil( Util * util ) { this->util = util; }

  private:
    int DIMX;
    int DIMY;

    Data * data;
    Util * util;

    enum { NO_THREE, WITH_THREE };

    int trySides( int x, int y, int flag );
    int doGridlockMove( int *, int *);
    int doNoGridlockMove( int *, int *);

    int get2_3Chain( int len, int c, int force );
    int getShortestChain( );
    int getFourthLine( int x, int y );
};

#endif // STRATEGY_H
