/* util.cpp
 *

 */

#include "util.h"
#include "data.h"

Util::Util( int dx, int dy )
  : DIMX(dx), DIMY(dy)
{ }

int Util::lineToIndex( int i, int j, int dir ) 
{
  if (dir == Data::HORIZONTAL) {
    return (i + j*DIMX);
  } 
  if (dir == Data::VERTICAL) {
    return (DIMX*(DIMY+1) + j + i*DIMY);
  } 
  return -1;
}

int Util::indexToLine(int index, int * i, int * j, int * dir) {
  if (index < 0 || index >= 2*DIMX*DIMY+DIMX+DIMY )
    return -1;
  if (index < DIMX*(DIMY+1) ) {
    *dir = Data::HORIZONTAL;
    *i = index % DIMX;
    *j = index / DIMX;
  } else {
    index -= DIMX*(DIMY+1);
    *dir = Data::VERTICAL;
    *i = index / DIMY;
    *j = index % DIMY;
  }
  return 0;
}

